vpp_device: disable IPv6 in containers
[csit.git] / resources / libraries / bash / function / device.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Licensed under the Apache License, Version 2.0 (the "License");
3 # you may not use this file except in compliance with the License.
4 # You may obtain a copy of the License at:
5 #
6 #     http://www.apache.org/licenses/LICENSE-2.0
7 #
8 # Unless required by applicable law or agreed to in writing, software
9 # distributed under the License is distributed on an "AS IS" BASIS,
10 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
11 # See the License for the specific language governing permissions and
12 # limitations under the License.
13
14 set -exuo pipefail
15
16 # This library defines functions used by multiple entry scripts.
17 # Deliberately not depending on common.sh to allow standalone usage.
18 # Keep functions ordered alphabetically, please.
19
20 function activate_wrapper () {
21
22     # Acts as wrapper for activate docker topology.
23     #
24     # Variables read:
25     # - ${1} - Node multiplicity of desired testbed.
26     # - ${2} - Node flavor string, usually describing the processor.
27     # - ${3} - CSIT-SUT-DCR image name and version.
28
29     set -exuo pipefail
30
31     enter_mutex || die
32     get_available_interfaces "${1}" "${2}" || die
33     start_topology_containers "${3}" || die
34     bind_interfaces_to_containers || die
35     set_env_variables || die
36     print_env_variables || die
37     exit_mutex || die
38 }
39
40
41 function bind_interfaces_to_containers () {
42
43     # Bind linux network interface to container and create symlink for PCI
44     # address in container.
45     #
46     # Variables read:
47     # - DCR_UUIDS - Docker Container UUIDs.
48     # - DCR_CPIDS - Docker Container PIDs (namespaces).
49     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
50     # - PCI_ADDR - PCI address of network device.
51     # - TG_NETDEVS - List of network devices allocated to TG container.
52     # Variables set:
53     # - NETDEV - Linux network interface.
54
55     set -exuo pipefail
56
57     for NETDEV in "${TG_NETDEVS[@]}"; do
58         get_pci_addr || die
59         link_target=$(readlink -f /sys/bus/pci/devices/"${PCI_ADDR}") || {
60             die "Reading symlink for PCI address failed!"
61         }
62         cmd="ln -s ${link_target} /sys/bus/pci/devices/${PCI_ADDR}"
63
64         sudo ip link set ${NETDEV} netns ${DCR_CPIDS[tg]} || {
65             die "Moving interface to ${DCR_CPIDS[tg]} namespace failed!"
66         }
67         docker exec "${DCR_UUIDS[tg]}" ${cmd} || {
68             die "Linking PCI address in container failed!"
69         }
70     done
71     for NETDEV in "${DUT1_NETDEVS[@]}"; do
72         get_pci_addr || die
73         link_target=$(readlink -f /sys/bus/pci/devices/"${PCI_ADDR}") || {
74             die "Reading symlink for PCI address failed!"
75         }
76         cmd="ln -s ${link_target} /sys/bus/pci/devices/${PCI_ADDR}"
77
78         sudo ip link set ${NETDEV} netns ${DCR_CPIDS[dut1]} || {
79             die "Moving interface to ${DCR_CPIDS[dut1]} namespace failed!"
80         }
81         docker exec "${DCR_UUIDS[dut1]}" ${cmd} ||  {
82             die "Linking PCI address in container failed!"
83         }
84     done
85 }
86
87
88 function bind_interfaces_to_driver () {
89
90     # Bind network interface specified by parameter to driver specified by
91     # parameter.
92     #
93     # Variables read:
94     # - ADDR - PCI address of network interface.
95     # - DRIVER - Kernel driver.
96
97     set -exuo pipefail
98
99     pci_path="/sys/bus/pci/devices/${ADDR}"
100     drv_path="/sys/bus/pci/drivers/${DRIVER}"
101     vd=$(cat ${pci_path}/vendor ${pci_path}/device) || {
102         die "Failed to retrieve interface details!"
103     }
104     set +e
105     echo ${vd} | sudo tee ${drv_path}/new_id
106     set -e
107     echo ${ADDR} | sudo tee ${pci_path}/driver/unbind || {
108         die "Failed to unbind interface ${ADDR}!"
109     }
110     echo ${ADDR} | sudo tee ${drv_path}/bind || {
111         die "Failed to bind interface ${ADDR}!"
112     }
113 }
114
115
116 function clean_environment () {
117
118     # Cleanup environment by removing topology containers and shared volumes
119     # and binding interfaces back to original driver.
120     #
121     # Variables read:
122     # - DCR_UUIDS - Docker Container UUIDs.
123     # - DUT1_PCIDEVS - List of PCI addresses of devices of DUT1 container.
124     # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
125     # Variables set:
126     # - ADDR - PCI address of network interface.
127     # - DRIVER - Kernel driver.
128
129     set -exuo pipefail
130
131     # Kill docker containers.
132     docker rm --force "${DCR_UUIDS[@]}" || die "Cleanup containers failed!"
133
134     # Check if there are some leftover containers and remove all. Command will
135     # not fail in case there are no containers to remove.
136     docker rm --force $(docker ps -q --filter name=${DCR_UUIDS[dut1]}) || {
137         warn "Failed to remove hanged containers or nothing to remove!"
138     }
139
140     # Rebind interfaces back to kernel drivers.
141     for ADDR in ${TG_PCIDEVS[@]}; do
142         DRIVER="${TG_DRIVERS[0]}"
143         bind_interfaces_to_driver || die
144     done
145     for ADDR in ${DUT1_PCIDEVS[@]}; do
146         DRIVER="${DUT1_DRIVERS[0]}"
147         bind_interfaces_to_driver || die
148     done
149 }
150
151
152 function clean_environment_on_exit () {
153
154     # Cleanup environment by removing topology containers and binding
155     # interfaces back to original driver only if exit code is not 0.
156     # This function acts as workaround as 'set -eu' does not trigger ERR trap.
157
158     set -exuo pipefail
159
160     if [ $? -ne 0 ]; then
161         clean_environment || die
162     fi
163 }
164
165
166 function deactivate_wrapper () {
167
168     # Acts as wrapper for deactivate docker topology.
169     #
170     # Variables read:
171     # - ${@} - CSIT environment variables.
172
173     set -exuo pipefail
174
175     enter_mutex || die
176     read_env_variables "${@}" || die
177     clean_environment || die
178     exit_mutex || die
179 }
180
181
182 function die () {
183
184     # Print the message to standard error end exit with error code specified
185     # by the second argument.
186     #
187     # Duplicate of common.sh function, as this file is also used standalone.
188     #
189     # Hardcoded values:
190     # - The default error message.
191     # Arguments:
192     # - ${1} - The whole error message, be sure to quote. Optional
193     # - ${2} - the code to exit with, default: 1.
194
195     set -x
196     set +eu
197     warn "${1:-Unspecified run-time error occurred!}"
198     exit "${2:-1}"
199 }
200
201
202 function enter_mutex () {
203
204     # Enter mutual exclusion for protecting execution from starvation and
205     # deadlock.
206
207     set -exuo pipefail
208
209     mutex_timeout=3600
210     mutex_file="/tmp/mutex_file"
211
212     # Create mutex.
213     exec {lock_fd}>${mutex_file} || {
214         die "Mutex enter failed!"
215     }
216     flock --timeout "${mutex_timeout}" "${lock_fd}" || {
217         die "Calling flock() failed!"
218     }
219     # ----------------------
220     # Enter mutex succeeded.
221     warn "Mutex enter succeeded for PID $$."
222 }
223
224
225 function exit_mutex () {
226
227     # Exit mutual exclusion.
228
229     set -exuo pipefail
230
231     # ---------------------
232     # Remove mutex so we are not blocking others anymore.
233     flock -u "${lock_fd}" || {
234         die "Mutex destroy failed!"
235     }
236     warn "Mutex leave succeeded for PID $$."
237 }
238
239
240 function get_available_interfaces () {
241
242     # Find and get available Virtual functions.
243     #
244     # Arguments:
245     # - ${1} - Nodeness, as set by common.sh get_test_code.
246     # - ${2} - Flavor, as set by common.sh get_test_code.
247     # Variables set:
248     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
249     # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
250     # - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
251     # - DUT1_DRIVERS - List of interface drivers to DUT1 container.
252     # - TG_NETDEVS - List of network devices allocated to TG container.
253     # - TG_PCIDEVS - List of PCI addresses allocated to TG container.
254     # - TG_NETMACS - List of MAC addresses allocated to TG container.
255     # - TG_DRIVERS - List of interface drivers to TG container.
256
257     set -exuo pipefail
258
259     # Following code is specifing VFs ID based on nodeness and flavor.
260     # As there is great variability in hardware configuration outside LF,
261     # from bootstrap architecure point of view these are considered as flavors.
262     # Anyone can override flavor for its own machine and add condition here.
263     # See http://pci-ids.ucw.cz/v2.2/pci.ids for more info.
264     case_text="${1}_${2}"
265     case "${case_text}" in
266         "1n_skx")
267             # Add Intel Corporation XL710/X710 Virtual Function to the
268             # whitelist.
269             pci_id="0x154c"
270             tg_netdev=(enp24)
271             dut1_netdev=(enp59)
272             ;;
273        "1n_tx2")
274             # Add Intel Corporation XL710/X710 Virtual Function to the
275             # whitelist.
276             pci_id="0x154c"
277             tg_netdev=(enp5s2 enp5s3 enp5s4 enp5s5
278                        enp5s6 enp5s7 enp5s8 enp5s9)
279             tg_netdev+=(enp5s10 enp5s11 enp5s12 enp5s13
280                         enp5s14 enp5s15 enp5s16 enp5s17)
281             dut1_netdev=(enp145s2 enp145s3 enp145s4 enp145s5
282                          enp145s6 enp145s7 enp145s8 enp145s9)
283             dut1_netdev+=(enp145s10 enp145s11 enp145s12 enp145s13
284                           enp145s14 enp145s15 enp145s16 enp145s17)
285             ;;
286        "1n_vbox")
287             # Add Intel Corporation 82545EM Gigabit Ethernet Controller to the
288             # whitelist.
289             pci_id="0x100f"
290             tg_netdev=(enp0s8 enp0s9)
291             dut1_netdev=(enp0s16 enp0s17)
292             ;;
293         *)
294             die "Unknown specification: ${case_text}!"
295     esac
296
297     device_count=2
298
299     # TG side of connections.
300     TG_NETDEVS=()
301     TG_PCIDEVS=()
302     TG_NETMACS=()
303     TG_DRIVERS=()
304     TG_VLANS=()
305     # DUT1 side of connections.
306     DUT1_NETDEVS=()
307     DUT1_PCIDEVS=()
308     DUT1_NETMACS=()
309     DUT1_DRIVERS=()
310     DUT1_VLANS=()
311
312     # Find the first ${device_count} number of available TG Linux network
313     # VF device names. Only allowed VF PCI IDs are filtered.
314     for netdev in ${tg_netdev[@]}
315     do
316         for netdev_path in $(grep -l "${pci_id}" \
317                              /sys/class/net/${netdev}*/device/device \
318                              2> /dev/null)
319         do
320             if [[ ${#TG_NETDEVS[@]} -lt ${device_count} ]]; then
321                 tg_netdev_name=$(dirname ${netdev_path})
322                 tg_netdev_name=$(dirname ${tg_netdev_name})
323                 TG_NETDEVS+=($(basename ${tg_netdev_name}))
324             else
325                 break
326             fi
327         done
328         if [[ ${#TG_NETDEVS[@]} -eq ${device_count} ]]; then
329             break
330         fi
331     done
332
333     i=0
334     for netdev in "${TG_NETDEVS[@]}"; do
335         # Find the index of selected tg netdev among tg_netdevs
336         # e.g. enp8s5f7 is a vf of netdev enp8s5 with index 11
337         # and the corresponding dut1 netdev is enp133s13.
338         while [[ "${netdev}" != "${tg_netdev[$i]}"* ]]; do
339             ((i++))
340         done
341         # Rename tg netdev to dut1 netdev
342         # e.g. enp8s5f7 -> enp133s13f7
343         DUT1_NETDEVS+=(${netdev/${tg_netdev[$i]}/${dut1_netdev[$i]}})
344         # Don't need to reset i, all netdevs are sorted.
345     done
346
347     for NETDEV in "${TG_NETDEVS[@]}"; do
348         get_pci_addr
349         get_mac_addr
350         get_krn_driver
351         get_vlan_filter
352         TG_PCIDEVS+=(${PCI_ADDR})
353         TG_NETMACS+=(${MAC_ADDR})
354         TG_DRIVERS+=(${KRN_DRIVER})
355         TG_VLANS+=(${VLAN_ID})
356     done
357     for NETDEV in "${DUT1_NETDEVS[@]}"; do
358         get_pci_addr
359         get_mac_addr
360         get_krn_driver
361         get_vlan_filter
362         DUT1_PCIDEVS+=(${PCI_ADDR})
363         DUT1_NETMACS+=(${MAC_ADDR})
364         DUT1_DRIVERS+=(${KRN_DRIVER})
365         DUT1_VLANS+=(${VLAN_ID})
366     done
367
368     # We need at least two interfaces for TG/DUT1 for building topology.
369     if [ "${#TG_NETDEVS[@]}" -ne 2 ] || [ "${#DUT1_NETDEVS[@]}" -ne 2 ]; then
370         die "Not enough linux network interfaces found!"
371     fi
372     if [ "${#TG_PCIDEVS[@]}" -ne 2 ] || [ "${#DUT1_PCIDEVS[@]}" -ne 2 ]; then
373         die "Not enough pci interfaces found!"
374     fi
375 }
376
377
378 function get_krn_driver () {
379
380     # Get kernel driver from linux network device name.
381     #
382     # Variables read:
383     # - PCI_ADDR - PCI address of network device.
384     # Variables set:
385     # - KRN_DRIVER - Kernel driver of network device.
386
387     set -exuo pipefail
388
389     pci_path="/sys/bus/pci/devices/${PCI_ADDR}"
390     KRN_DRIVER="$(basename $(readlink -f ${pci_path}/driver))" || {
391         die "Failed to get kernel driver of PCI interface!"
392     }
393 }
394
395
396 function get_mac_addr () {
397
398     # Get MAC address from linux network device name.
399     #
400     # Variables read:
401     # - NETDEV - Linux network device name.
402     # Variables set:
403     # - MAC_ADDR - MAC address of network device.
404
405     set -exuo pipefail
406
407     if [ -d /sys/class/net/${NETDEV}/device ]; then
408         MAC_ADDR="$(</sys/class/net/${NETDEV}/address)" || {
409             die "Failed to get MAC address of linux network interface!"
410         }
411     fi
412 }
413
414
415 function get_pci_addr () {
416
417     # Get PCI address in <domain>:<bus:<device>.<func> format from linux network
418     # device name.
419     #
420     # Variables read:
421     # - NETDEV - Linux network device name.
422     # Variables set:
423     # - PCI_ADDR - PCI address of network device.
424
425     set -exuo pipefail
426
427     if [ -d /sys/class/net/${NETDEV}/device ]; then
428         PCI_ADDR=$(basename $(readlink /sys/class/net/${NETDEV}/device)) || {
429             die "Failed to get PCI address of linux network interface!"
430         }
431     fi
432     if [ ! -d /sys/bus/pci/devices/${PCI_ADDR} ]; then
433         die "PCI device ${NETDEV} doesn't exist!"
434     fi
435 }
436
437
438 function get_vlan_filter () {
439
440     # Get VLAN stripping filter from PF searched by mac adress.
441     #
442     # Variables read:
443     # - MAC_ADDR - MAC address of VF.
444     # Variables set:
445     # - VLAN_ID - VLAN ids.
446
447     set -exuo pipefail
448
449     # Sed regular expression pattern.
450     exp="s/^.*vlan ([[:digit:]]+).*$/\1/"
451     VLAN_ID=$(ip link | grep vlan | grep ${MAC_ADDR} | sed -re "${exp}") || true
452     VLAN_ID="${VLAN_ID:-0}"
453 }
454
455
456 function installed () {
457
458     # Check if the given utility is installed. Fail if not installed.
459     #
460     # Duplicate of common.sh function, as this file is also used standalone.
461     #
462     # Arguments:
463     # - ${1} - Utility to check.
464     # Returns:
465     # - 0 - If command is installed.
466     # - 1 - If command is not installed.
467
468     set -exuo pipefail
469
470     command -v "${1}"
471 }
472
473
474 function print_env_variables () {
475
476     # Get environment variables prefixed by CSIT_.
477
478     set -exuo pipefail
479
480     env | grep CSIT_ || true
481 }
482
483
484 function read_env_variables () {
485
486     # Read environment variables from parameters.
487     #
488     # Arguments:
489     # - ${@} - Variables passed as an argument.
490     # Variables read, set or exported: Multiple,
491     # see the code for the current list.
492     # TODO: Do we need to list them and their meanings?
493
494     set -exuo pipefail
495
496     for param in "$@"; do
497         export "${param}"
498     done
499     declare -gA DCR_UUIDS
500     DCR_UUIDS+=([tg]="${CSIT_TG_UUID}")
501     DCR_UUIDS+=([dut1]="${CSIT_DUT1_UUID}")
502     TG_PCIDEVS=("${CSIT_TG_INTERFACES_PORT1_PCI}")
503     TG_DRIVERS=("${CSIT_TG_INTERFACES_PORT1_DRV}")
504     TG_VLANS+=("${CSIT_TG_INTERFACES_PORT1_VLAN}")
505     TG_PCIDEVS+=("${CSIT_TG_INTERFACES_PORT2_PCI}")
506     TG_DRIVERS+=("${CSIT_TG_INTERFACES_PORT2_DRV}")
507     TG_VLANS+=("${CSIT_TG_INTERFACES_PORT2_VLAN}")
508     DUT1_PCIDEVS=("${CSIT_DUT1_INTERFACES_PORT1_PCI}")
509     DUT1_DRIVERS=("${CSIT_DUT1_INTERFACES_PORT1_DRV}")
510     DUT1_VLANS+=("${CSIT_DUT1_INTERFACES_PORT1_VLAN}")
511     DUT1_PCIDEVS+=("${CSIT_DUT1_INTERFACES_PORT2_PCI}")
512     DUT1_DRIVERS+=("${CSIT_DUT1_INTERFACES_PORT2_DRV}")
513     DUT1_VLANS+=("${CSIT_DUT1_INTERFACES_PORT2_VLAN}")
514 }
515
516
517 function set_env_variables () {
518
519     # Set environment variables.
520     #
521     # Variables read:
522     # - DCR_UUIDS - Docker Container UUIDs.
523     # - DCR_PORTS - Docker Container's SSH ports.
524     # - DUT1_NETMACS - List of network devices MAC addresses of DUT1 container.
525     # - DUT1_PCIDEVS - List of PCI addresses of devices of DUT1 container.
526     # - DUT1_DRIVERS - List of interface drivers to DUT1 container.
527     # - TG_NETMACS - List of network devices MAC addresses of TG container.
528     # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
529     # - TG_DRIVERS - List of interface drivers to TG container.
530     # Variables set: TODO.
531
532     set -exuo pipefail
533
534     set -a
535     CSIT_TG_HOST="$(hostname --all-ip-addresses | awk '{print $1}')" || {
536         die "Reading hostname IP address failed!"
537     }
538     CSIT_TG_PORT="${DCR_PORTS[tg]#*:}"
539     CSIT_TG_UUID="${DCR_UUIDS[tg]}"
540     CSIT_TG_ARCH="$(uname -i)" || {
541         die "Reading machine architecture failed!"
542     }
543     CSIT_DUT1_HOST="$(hostname --all-ip-addresses | awk '{print $1}')" || {
544         die "Reading hostname IP address failed!"
545     }
546     CSIT_DUT1_PORT="${DCR_PORTS[dut1]#*:}"
547     CSIT_DUT1_UUID="${DCR_UUIDS[dut1]}"
548     CSIT_DUT1_ARCH="$(uname -i)" || {
549         die "Reading machine architecture failed!"
550     }
551     CSIT_TG_INTERFACES_PORT1_MAC="${TG_NETMACS[0]}"
552     CSIT_TG_INTERFACES_PORT1_PCI="${TG_PCIDEVS[0]}"
553     CSIT_TG_INTERFACES_PORT1_DRV="${TG_DRIVERS[0]}"
554     CSIT_TG_INTERFACES_PORT1_VLAN="${TG_VLANS[0]}"
555     CSIT_TG_INTERFACES_PORT2_MAC="${TG_NETMACS[1]}"
556     CSIT_TG_INTERFACES_PORT2_PCI="${TG_PCIDEVS[1]}"
557     CSIT_TG_INTERFACES_PORT2_DRV="${TG_DRIVERS[1]}"
558     CSIT_TG_INTERFACES_PORT2_VLAN="${TG_VLANS[1]}"
559     CSIT_DUT1_INTERFACES_PORT1_MAC="${DUT1_NETMACS[0]}"
560     CSIT_DUT1_INTERFACES_PORT1_PCI="${DUT1_PCIDEVS[0]}"
561     CSIT_DUT1_INTERFACES_PORT1_DRV="${DUT1_DRIVERS[0]}"
562     CSIT_DUT1_INTERFACES_PORT1_VLAN="${DUT1_VLANS[0]}"
563     CSIT_DUT1_INTERFACES_PORT2_MAC="${DUT1_NETMACS[1]}"
564     CSIT_DUT1_INTERFACES_PORT2_PCI="${DUT1_PCIDEVS[1]}"
565     CSIT_DUT1_INTERFACES_PORT2_DRV="${DUT1_DRIVERS[1]}"
566     CSIT_DUT1_INTERFACES_PORT2_VLAN="${DUT1_VLANS[1]}"
567     set +a
568 }
569
570
571 function start_topology_containers () {
572
573     # Starts csit-sut-dcr docker containers for TG/DUT1.
574     #
575     # Variables read:
576     # - CSIT_DIR - Path to existing root of local CSIT git repository.
577     # Variables set:
578     # - DCR_UUIDS - Docker Container UUIDs.
579     # - DCR_PORTS - Docker Container SSH TCP ports.
580     # - DCR_CPIDS - Docker Container PIDs (namespaces).
581
582     set -exuo pipefail
583
584     if ! installed docker; then
585         die "Docker not present. Please install before continue!"
586     fi
587
588     # If the IMAGE is not already loaded then docker run will pull the IMAGE,
589     # and all image dependencies, before it starts the container.
590     dcr_image="${1}"
591     # Run the container in the background and print the new container ID.
592     dcr_stc_params="--detach=true "
593     # Give extended privileges to this container. A "privileged" container is
594     # given access to all devices and able to run nested containers.
595     dcr_stc_params+="--privileged "
596     # Publish all exposed ports to random ports on the host interfaces.
597     dcr_stc_params+="--publish-all "
598     # Automatically remove the container when it exits.
599     dcr_stc_params+="--rm "
600     # Size of /dev/shm.
601     dcr_stc_params+="--shm-size 512M "
602     # Override access to PCI bus by attaching a filesystem mount to the
603     # container.
604     dcr_stc_params+="--mount type=tmpfs,destination=/sys/bus/pci/devices "
605     # Mount vfio to be able to bind to see bound interfaces. We cannot use
606     # --device=/dev/vfio as this does not see newly bound interfaces.
607     dcr_stc_params+="--volume /dev/vfio:/dev/vfio "
608     # Mount docker.sock to be able to use docker deamon of the host.
609     dcr_stc_params+="--volume /var/run/docker.sock:/var/run/docker.sock "
610     # Mount /opt/boot/ where VM kernel and initrd are located.
611     dcr_stc_params+="--volume /opt/boot/:/opt/boot/ "
612     # Mount host hugepages for VMs.
613     dcr_stc_params+="--volume /dev/hugepages/:/dev/hugepages/ "
614     # Disable IPv6.
615     dcr_stc_params+="--sysctl net.ipv6.conf.all.disable_ipv6=1 "
616     dcr_stc_params+="--sysctl net.ipv6.conf.default.disable_ipv6=1 "
617
618     # Docker Container UUIDs.
619     declare -gA DCR_UUIDS
620     # Docker Container SSH TCP ports.
621     declare -gA DCR_PORTS
622     # Docker Container PIDs (namespaces).
623     declare -gA DCR_CPIDS
624
625     # Run TG and DUT1. As initial version we do support only 2-node.
626     params=(${dcr_stc_params} --name csit-tg-$(uuidgen) ${dcr_image})
627     DCR_UUIDS+=([tg]=$(docker run "${params[@]}")) || {
628         die "Failed to start TG docker container!"
629     }
630     params=(${dcr_stc_params} --name csit-dut1-$(uuidgen) ${dcr_image})
631     DCR_UUIDS+=([dut1]=$(docker run "${params[@]}")) || {
632         die "Failed to start DUT1 docker container!"
633     }
634
635     trap 'clean_environment_on_exit' EXIT || {
636         die "Trap attempt failed, please cleanup manually. Aborting!"
637     }
638
639     # Get Containers TCP ports.
640     params=(${DCR_UUIDS[tg]})
641     DCR_PORTS+=([tg]=$(docker port "${params[@]}")) || {
642         die "Failed to get port of TG docker container!"
643     }
644     params=(${DCR_UUIDS[dut1]})
645     DCR_PORTS+=([dut1]=$(docker port "${params[@]}")) || {
646         die "Failed to get port of DUT1 docker container!"
647     }
648
649     # Get Containers PIDs.
650     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[tg]})
651     DCR_CPIDS+=([tg]=$(docker inspect "${params[@]}")) || {
652         die "Failed to get PID of TG docker container!"
653     }
654     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[dut1]})
655     DCR_CPIDS+=([dut1]=$(docker inspect "${params[@]}")) || {
656         die "Failed to get PID of DUT1 docker container!"
657     }
658 }
659
660 function warn () {
661     # Print the message to standard error.
662     #
663     # Duplicate of common.sh function, as this file is also used standalone.
664     #
665     # Arguments:
666     # - ${@} - The text of the message.
667
668     set -exuo pipefail
669
670     echo "$@" >&2
671 }